#pragma once

using namespace System::Collections::Generic;
using namespace System::IO;
using namespace System;

typedef Dictionary<String ^,Dictionary<String ^,String ^> ^>	IniFileDictionary;

ref class IniStream
{
private:
		String ^m_fileName;

		IniFileDictionary ^m_data;
		bool m_modified;

		String ^m_currentSection;
public:
	IniStream(String ^fileName);
	void Open(void);
	void Open(String ^fileName);
	void Close(void);

	property String ^CurrentSection
	{
		void set(String ^newSection) {m_currentSection=newSection;}
	}

	property String ^default[String ^,String ^]
	{
		String ^get(String ^section,String ^name)
		{
			return ReadString(section,name,"");
		}
		void set(String ^section,String ^name,String ^value)
		{
			WriteString(section,name,value);
		}
	}

	//Devuelve el nmero de secciones que hay
	property int CountSections
	{
		int get(void) {return m_data->Count;}
	}

	property array<String^> ^Sections
	{
		array<String^>^get(void)
		{
			array<String ^> ^tmpArr=gcnew array<String^>(m_data->Keys->Count);
			m_data->Keys->CopyTo(tmpArr,0);
			return tmpArr;
		}
	}

	virtual property int Count
	{
		int get(void){return m_data->Keys->Count;}
	}

	String ^ReadString(String ^section,String ^name,String ^default);
	String ^ReadString(String ^name,String ^default);
	String ^ReadString(String ^name);
	void    WriteString(String ^section,String ^name,String ^default);
	void    WriteString(String ^name,String ^default);

	Int32   ReadInt32(String ^section,String ^name,Int32 default);
	Int32	ReadInt32(String ^name,Int32 default);
	void    WriteInt32(String ^section,String ^name,Int32 value);
	void    WriteInt32(String ^name,Int32 value);

	bool	ReadBool(String ^section,String ^name,bool def);
	bool	ReadBool(String ^name,bool def);
	void	WriteBool(String ^section,String ^name,bool value);
	void	WriteBool(String ^name,bool value);
};
